# This code is copyrighted by Stephan Richter and
# Thomas Foerster in September, 2001.
#
# written by Stephan Richter
# Last updated: October 4, 2001

# OQL grammar,
# based on Stephan's OQL by example -> see help/Syntax.dtml

#TODO:
# * extend names to allow all Zopish weirdness --> This can be done by using " " or ' '.
#   I think I fixed that already.

oqlrules = """

## goal 
statement_list ::

## reduce rules
## form is
## @R name :: lhs >> substitution

@R statement_list1 :: statement_list >> statement
@R statement_list2 :: statement_list >> statement statement_list

## statements
@R statement1 :: statement >>
    CREATE PRODUCT identifier AS product_type ;
@R statement2 :: statement >>
    CREATE CLASS identifier IN identifier 
    opt_assignment opt_option opt_propertysheet_declaration opt_inherit ;
@R statement3 :: statement >>
    CREATE INDEX identifier ON reference_list index_list opt_restrict opt_recursive ; 
@R statement8 :: statement >>
    ALTER CLASS reference alter_statement ; 
@R statement4 :: statement >>
    INSERT reference INTO reference
    opt_assignment ;
@R statement5 :: statement >>
    UPDATE reference_list opt_in SET assignment_list opt_restrict opt_recursive ;
@R statement6 :: statement >>
    DELETE reference_list opt_from opt_restrict opt_recursive ;
@R statement7 :: statement >>
    SELECT selection opt_from opt_restrict opt_orderby opt_limit opt_recursive ;
    
## CREATE statement
@R product_type1 :: product_type >> ZCLASS
@R product_type2 :: product_type >> PYTHON
@R opt_inherit0 :: opt_inherit >>
@R opt_inherit1 :: opt_inherit >> INHERIT reference_list
@R opt_propertysheet_declaration0 :: opt_propertysheet_declaration >>
@R opt_propertysheet_declaration1 :: opt_propertysheet_declaration >> DECLARE propertysheet_list
@R opt_option0 :: opt_option >>
@R opt_option1 :: opt_option >> OPTION assignment_list


## ALTER statement
@R alter_statement1 :: alter_statement >> ADD object_type prop_declaration
@R alter_statement2 :: alter_statement >> RENAME reference TO reference
@R alter_statement3 :: alter_statement >> DELETE reference_list

@R object_type1 :: object_type >> CLASS
@R object_type2 :: object_type >> PROPERTY


## INSERT statement
@R opt_assignment0 :: opt_assignment >>
@R opt_assignment1 :: opt_assignment >> SET assignment_list

## Assignments
@R assignment_list1 :: assignment_list >> assignment
@R assignment_list2 :: assignment_list >> assignment , assignment_list

@R assignment1 :: assignment >> reference assign expression
@R assignment2 :: assignment >> reference plusequal expression
@R assignment3 :: assignment >> reference minusequal expression
@R assignment4 :: assignment >> reference mulequal expression
@R assignment5 :: assignment >> reference divequal expression
@R assignment6 :: assignment >> reference modequal expression

## UPDATE statements
@R opt_in0 :: opt_in >>
@R opt_in1 :: opt_in >> IN reference_list

@R opt_restrict0 :: opt_restrict >>
@R opt_restrict1 :: opt_restrict >> WHERE expression

@R opt_recursive0 :: opt_recursive >>
@R opt_recursive1 :: opt_recursive >> RECURSIVE

## FROM option
@R opt_from0 :: opt_from >>
@R opt_from1 :: opt_from >> FROM reference_list

## SELECT statement
@R selection1 :: selection >> ast
@R selection2 :: selection >> reference_list

## ORDER BY option
@R opt_orderby0 :: opt_orderby >>
@R opt_orderby1 :: opt_orderby >> ORDER BY order_list
@R order_list0 :: order_list >> order_item
@R order_list1 :: order_list >> order_item , order_list
@R order_item :: order_item >> identifier opt_order_dir
@R opt_order_dir0 :: opt_order_dir >>
@R opt_order_dir1 :: opt_order_dir >> ASC
@R opt_order_dir2 :: opt_order_dir >> DESC

## LIMIT option
@R opt_limit0 :: opt_limit >> 
@R opt_limit1 :: opt_limit >> LIMIT integer opt_offset
@R opt_offset0 :: opt_offset >> 
@R opt_offset1 :: opt_offset >> OFFSET integer

## Index List
@R index_list :: index_list >> ( opt_index_declaration )
@R opt_index_declaration0 :: opt_index_declaration >> index_declaration
@R opt_index_declaration1 :: opt_index_declaration >> index_declaration_list
@R index_declaration_list1 :: index_declaration_list >> index_declaration
@R index_declaration_list2 :: index_declaration_list >> index_declaration , index_declaration_list
@R index_declaration :: index_declaration >> identifier : identifier 


## PropertySheets

@R propertysheet_list1 :: propertysheet_list >> propertysheet
@R propertysheet_list2 :: propertysheet_list >> propertysheet , propertysheet_list

@R propertysheet :: propertysheet >> identifier { opt_prop_declaration }
@R opt_prop_declaration0 :: opt_prop_declaration >>
@R opt_prop_declaration1 :: opt_prop_declaration >> prop_declaration_list
@R prop_declaration_list1 :: prop_declaration_list >> prop_declaration
@R prop_declaration_list2 :: prop_declaration_list >> prop_declaration , prop_declaration_list
@R prop_declaration :: prop_declaration >>
    reference : identifier opt_default
    ## XXX property types have to be restricted to Zope ones

@R opt_default0 :: opt_default >>
@R opt_default1 :: opt_default >> DEFAULT expression


## Expressions from Python Language Reference

## Atoms

@R atom1 :: atom >> identifier
@R atom2 :: atom >> literal
@R atom3 :: atom >> enclosure
@R enclosure1 :: enclosure >> parenth_form
@R enclosure2 :: enclosure >> list_display
@R enclosure3 :: enclosure >> dict_display
@R enclosure4 :: enclosure >> string_conversion

## Enclosures
@R parenth_form :: parenth_form >> ( expression_list )
@R list_display :: list_display >> [ expression_list ]
@R dict_display :: dict_display >> { key_datum_list }
@R key_datum_list1 :: key_datum_list >> key_datum opt_comma
@R key_datum_list2 :: key_datum_list >> key_datum , key_datum_list
@R key_datum :: key_datum >> expression : expression
@R opt_comma1 :: opt_comma >>
@R opt_comma2 :: opt_comma >> ,
@R string_conversion :: string_conversion >> ` expression `

## literal tokens --> see oqlgen.py for definition
@R literal1 :: literal >> string_literal
@R literal2 :: literal >> integer
@R literal3 :: literal >> longinteger
@R literal4 :: literal >> floatnumber
@R literal5 :: literal >> datetime
## XXX imagnumber ignored (for now)

## Primaries
@R primary1 :: primary >> reference
@R primary2 :: primary >> subscription
@R primary3 :: primary >> call
## XXX primary -> slicing ignored 
@R reference1 :: reference >> atom
@R reference2 :: reference >> attribute_ref

@R reference_list1 :: reference_list >> reference
@R reference_list2 :: reference_list >> reference , reference_list
@R attribute_ref :: attribute_ref >> primary . identifier
@R subscription :: subscription >> primary [ expression_list ]
@R call :: call >> primary ( opt_argument_list opt_comma )
@R opt_argument_list0 :: opt_argument_list >>
@R opt_argument_list1 :: opt_argument_list >> argument_list
@R argument_list1 :: argument_list >> positional_arguments opt_keyword_arguments
@R argument_list2 :: argument_list >> keyword_arguments
@R opt_keyword_arguments1 :: opt_keyword_arguments >>
@R opt_keyword_arguments2 :: opt_keyword_arguments >> keyword_arguments
@R positional_arguments :: positional_arguments >> expression_list
@R keyword_arguments :: keyword_arguments >> keyword_item_list
@R keyword_item_list1 :: keyword_item_list >> keyword_item
@R keyword_item_list2 :: keyword_item_list >> keyword_item , keyword_item_list
@R keyword_item :: keyword_item >> identifier assign expression

## Operators
@R power1 :: power >> primary
@R power2 :: power >> primary dast u_expr 

## Unary operations
@R u_expr1 :: u_expr >> power
@R u_expr2 :: u_expr >> minus u_expr
@R u_expr3 :: u_expr >> plus u_expr
@R u_expr4 :: u_expr >> tilde u_expr

## Binary operations
@R m_expr1 :: m_expr >> u_expr
@R m_expr2 :: m_expr >> m_expr ast u_expr
@R m_expr3 :: m_expr >> m_expr slash u_expr
@R m_expr4 :: m_expr >> m_expr percent u_expr
@R a_expr1 :: a_expr >> m_expr
@R a_expr2 :: a_expr >> a_expr plus m_expr
@R a_expr3 :: a_expr >> a_expr minus m_expr

## Shift expressions
@R shift_expr1 :: shift_expr >> a_expr
@R shift_expr2 :: shift_expr >> shift_expr dgreater a_expr 
@R shift_expr3 :: shift_expr >> shift_expr dless a_expr 

## Binary bit operations
@R and_expr1 :: and_expr >> shift_expr
@R and_expr2 :: and_expr >> and_expr amper shift_expr
@R or_expr1  :: or_expr  >> and_expr
@R or_expr2  :: or_expr  >> or_expr pipe and_expr
@R xor_expr1 :: xor_expr >> or_expr
@R xor_expr2 :: xor_expr >> xor_expr circumflex or_expr

## Comparisons
@R comparison :: comparison >> or_expr opt_comp_expr
@R opt_comp_expr0 :: opt_comp_expr >>
@R opt_comp_expr1 :: opt_comp_expr >> comparison_operator comparison
@R comparison_operator1 :: comparison_operator >> less 
@R comparison_operator2 :: comparison_operator >> greater
@R comparison_operator3 :: comparison_operator >> equal 
@R comparison_operator4 :: comparison_operator >> gtequal 
@R comparison_operator5 :: comparison_operator >> ltequal 
@R comparison_operator6 :: comparison_operator >> nequal 
@R comparison_operator7 :: comparison_operator >> IS
@R comparison_operator8 :: comparison_operator >> IS NOT
@R comparison_operator9 :: comparison_operator >> IN
@R comparison_operator10 :: comparison_operator >> NOT IN

## Boolean Operations
@R expression1 :: expression >> or_test
@R expression2 :: expression >> lambda_form
@R or_test1 :: or_test >> and_test
@R or_test2 :: or_test >> or_test OR and_test
@R and_test1 :: and_test >> not_test
@R and_test2 :: and_test >> and_test AND not_test
@R not_test1 :: not_test >> comparison
@R not_test2 :: not_test >> NOT not_test
@R lambda_form :: lambda_form >> LAMBDA opt_parameter_list : expression

## Expression lists
@R expression_list1 :: expression_list >> expression
@R expression_list2 :: expression_list >> expression , expression_list
   ## XXX NOTE: trailing commas ignored for expressions lists to make the rule
   ## more general --> positional arguments...

## Parameter Lists
@R opt_parameter_list0 :: opt_parameter_list >>
@R opt_parameter_list1 :: opt_parameter_list >> parameter_list
@R parameter_list :: parameter_list >> opt_def_param_list last_element

@R opt_def_param_list0 :: opt_def_param_list >>
@R opt_def_param_list1 :: opt_def_param_list >> def_param_list
@R def_param_list0 :: def_param_list >> 
@R def_param_list1 :: def_param_list >> def_param_list , defparameter
@R last_element1 :: last_element >> ast identifier opt_dastident
@R last_element2 :: last_element >> dast identifier 
@R last_element3 :: last_element >> defparameter opt_comma
@R opt_dastident0 :: opt_dastident >>
@R opt_dastident1 :: opt_dastident >> , dast identifier 

@R defparameter1 :: defparameter >> parameter assign expression
@R defparameter2 :: defparameter >> parameter
@R parameter1 :: parameter >> identifier
@R parameter2 :: parameter >> ( sublist )
@R sublist :: sublist >> parameter opt_param_list_append opt_comma
@R opt_param_list_append0 :: opt_param_list_append >>
@R opt_param_list_append1 :: opt_param_list_append >> , parameter opt_param_list_append
"""

# terminal symbols (as defined in oqlgen.py)
# identifier string_literal integer longinteger floatnumber plus minus dast ast slash percent
# dless less ltequal dgreater greater gtequal nequal equal amper or circumflex tilde
# assign

### list of all nonterminal symbols
nonterms = """
statement_list statement product_type opt_option opt_inherit opt_propertysheet_declaration opt_assignment
reference_list opt_from opt_in opt_restrict opt_recursive assignment_list selection propertysheet_list
assignment_list assignment assign_op expression boolean_expression propertysheet propertysheet_list
opt_prop_declaration prop_declaration_list prop_declaration opt_default atom literal enclosure parenth_form
opt_orderby opt_order_dir order_item order_list opt_limit opt_offset alter_statement object_type
list_display dict_display string_conversion expression_list key_datum_list opt_comma key_datum primary
attribute_ref reference_list subscription call opt_argument_list argument_list positional_arguments
opt_keyword_arguments keyword_arguments keyword_item_list keyword_item power u_expr m_expr a_expr shift_expr
and_expr xor_expr or_expr opt_comp_expr comparison comparison_operator or_test lambda_form and_test not_test
opt_parameter_list expression_list parameter_list last_element opt_def_param_list defparameter parameter
sublist opt_param_list_append opt_dastident reference def_param_list
opt_index_declaration index_declaration_list index_declaration index_list
"""

### keyword list
keywords = """
ADD ALTER AS ASC BY CLASS CREATE DECLARE DEFAULT DELETE DESC FROM IN INDEX INHERIT INSERT INTO
LIMIT OFFSET ON OPTION ORDER PROPERTY PRODUCT PYTHON RECURSIVE RENAME SELECT SET TO UPDATE WHERE ZCLASS
NOT IS AND OR XOR LAMBDA
"""

### punctuation chars
puncts = """(){}[],.:`;"""



